/*
 ***********************************************************************
 *
 *                           Copyright 
 *    Copyright  2000 Force Computer, Inc., a Solectron company. All rights reserved. 
 *     Digital Equipment Corporation 1995. All rights reserved.
 *
 *    Restricted Rights: Use, duplication, or disclosure by the U.S.
 *    Government is subject to restrictions as set forth in subparagraph
 *    (c) (1) (ii) of DFARS 252.227-7013, or in FAR 52.227-19, or in FAR
 *    52.227-14 Alt. III, as applicable.
 *
 *    This software is proprietary to and embodies the confidential
 *    technology of Force Computer Incorporated and other parties.
 *    Possession, use, or copying of this software and media is authorized
 *    only pursuant to a valid written license from Force or an
 *    authorized sublicensor.
 *
 ***********************************************************************
 *    File Name:        ttsfeats.h
 *    Author:           Kevin Bruckert
 *    Creation Date:    07/23/1997
 *
 *    Functionality:    Define the TTS Features
 *
 ***********************************************************************
 *    Revision History:
 *
 *  Rev Name    Date        Description
 *  --- -----   ----------- --------------------------------------------
 *  001 KSB     07/23/1997  Creation Date
 *  002 CAB		10/18/2000	Changed copyright info
 */

#ifndef _TTS_FEATS_HEADER
#define _TTS_FEATS_HEADER

#define TTS_FEATS_MULTILANG     0x00000001L
#define TTS_FEATS_TYPINGMODE    0x00000002L
#define TTS_FEATS_FASTTALK      0x00000004L
#define TTS_FEATS_HIGHTLIGHTING 0x00000008L
#define TTS_FEATS_MENUTALK      0x00000010L

#endif  // _TTS_FEATS_HEADER
