/*
 ***********************************************************************
 *
 *                           Coryright (c)
 *     Digital Equipment Corporation 1995. All rights reserved.
 *
 *    Restricted Rights: Use, duplication, or disclosure by the U.S.
 *    Government is subject to restrictions as set forth in subparagraph
 *    (c) (1) (ii) of DFARS 252.227-7013, or in FAR 52.227-19, or in FAR
 *    52.227-14 Alt. III, as applicable.
 *
 *    This software is proprietary to and embodies the confidential
 *    technology of Digital Equipment Corporation and other parties.
 *    Possession, use, or copying of this software and media is authorized
 *    only pursuant to a valid written license from Digital or an
 *    authorized sublicensor.
 *
 ***********************************************************************
 *    File Name:	cpg_850.c
 *    Author:
 *    Creation Date:
 *
 *    Functionality:
 * language code page switching ...  code page definition file ...
 * see file lng_main.c ...
 *
 ***********************************************************************
 *    Revision History:
 * 	001	02/02/96	Changed inlcude from cpg_def.h to iso_char.h MGS
 */

#include	"iso_char.h"

int	code_page_number = 850;
unsigned char code_page_table[] = {

	0x00,	0x01,	0x02,	0x03,	0x04,	0x05,	0x06,	0x07,	0x08,	0x09,
	0x0a,	0x0b,	0x0c,	0x0d,	0x0e,	0x0f,	0x10,	0x11,	0x12,	0x13,
	0x14,	C_SECT,	0x16,	0x17,	0x18,	0x19,	0x1a,	0x1b,	0x1c,	0x1d,
	0x1e,	0x1f,	0x20,	0x21,	0x22,	0x23,	0x24,	0x25,	0x26,	0x27,	
	0x28,	0x29,	0x2a,	0x2b,	0x2c,	0x2d,	0x2e,	0x2f,	0x30,	0x31,
	0x32,	0x33,	0x34,	0x35,	0x36,	0x37,	0x38,	0x39,	0x3a,	0x3b,
	/*60*/
	0x3c,	0x3d,	0x3e,	0x3f,	0x40,	0x41,	0x42,	0x43,	0x44,	0x45,
	0x46,	0x47,	0x48,	0x49,	0x4a,	0x4b,	0x4c,	0x4d,	0x4e,	0x4f,
	0x50,	0x51,	0x52,	0x53,	0x54,	0x55,	0x56,	0x57,	0x58,	0x59,
	0x5a,	0x5b,	0x5c,	0x5d,	0x5e,	0x5f,	0x60,	0x61,	0x62,	0x63,
	/*100*/
	0x64,	0x65,	0x66,	0x67,	0x68,	0x69,	0x6a,	0x6b,	0x6c,	0x6d,
	0x6e,	0x6f,	0x70,	0x71,	0x72,	0x73,	0x74,	0x75,	0x76,	0x77,
	0x78,	0x79,	0x7a,	0x7b,	0x7c,	0x7d,	0x7e,	0x7f,
/* 0x80 - 0x8f */	
	C_CD_C, C_UM_u,
	C_AC_e,	C_CF_a,	C_UM_a,	C_GR_a,	C_RI_a,	C_CD_c,	C_CF_e,	C_UM_e,	C_GR_e,	C_UM_i,
	C_CF_i,	C_GR_i,	C_UM_A,	C_RI_A,
/* 0x90 - 0x9f */	
	C_AC_E,	C_ae,		0x00,		C_AC_o,	C_UM_o,	C_GR_o,
	C_CF_u,	C_AC_u,	C_UM_y,	C_UM_O,	C_UM_U,	C_SL_o,	C_POUN,	C_OB_O,	C_MULT,	0x00,
/* 0xa0 - 0xaf */
	C_AC_a,	C_AC_i,	C_AC_o,	C_AC_u,	C_TL_n,	C_TL_N,	C_FORD,	C_MORD,	C_IQU,	C_REG,
	C_NOT,	C_F12,	C_F14,	C_IEX,	C_DAPL,	C_DAPR,
/* 0xb0 - 0xbf */	
	0x00,		0x00,		0x00,		C_PIPE,
	0x00,		C_AC_A,		C_CF_A,		C_GR_A,
	C_COPY,		0x00,		0x00,		0x00,
	0x00,		C_CENT,		C_YEN,		0x00,
/* 0xc0 - 0xcf */	
	0x00,		0x00,		0x00,		0x00,
	0x00,		0x00,		C_TL_a,		C_TL_A,
	0x00,		0x00,		0x00,		0x00,
	0x00,		0x00,		0x00,		0x00,
/* 0xd0 - 0xdf */	
	0x00,		0x00,		C_CF_E,		C_UM_E,
	C_GR_E,		0x00,		C_GR_I,		C_CF_I,
	C_UM_I,		0x00,		0x00,		0x00,
	0x00,		0x00,		C_AC_I,		0x00,
/* 0xe0 - 0xef */	
	C_AC_O, 	C_esZ,		C_CF_O,		C_GR_O,
	C_TL_o,		C_TL_O,		0x00,		C_thorn,
	C_THORN,	C_AC_U,		C_CF_U,		C_AC_Y,
	C_AC_y,		0x00,		0x00,		0x00,
/* 0xf0 - 0xff */	
	0x00,		C_PLMI,		0x00,		C_F34,
	C_PARA,		0x00,		C_DIV,		0x00,
	C_RING,		0x00,		C_CDOT,		C_S1,
	C_S3,		C_S2,		0x00,		0x00	};

